	if (jQuery) 	
		jQuery(document).ready(init);	

	var categoriesById;
	var greatestId;
	
	function init() {
		categoriesById = new Array();
		greatestId = 0;
		jQuery("#catsList").html("");
		var catsText = $("#content").val();
		var lines = catsText.split(String.fromCharCode(10));
		var lastIdForLevel = new Array();
		
		for (var i = 0; i < lines.length; i++) {
			var currLine = jQuery.trim(lines[i]);
			if (!currLine)
				continue;

			var cat = buildCatObject(currLine);
			if (!cat)
				continue;
									
			cat.parentId = null;
			while (cat.level > 0 && !lastIdForLevel[cat.level - 1])
				cat.level--;
			lastIdForLevel.splice(cat.level,90,cat.id);	
			if (cat.level > 0) 
				cat.parentId = lastIdForLevel[cat.level - 1];

			categoriesById[cat.id] = cat;			
			buildCatHtml(cat);
				
		}
		//dumpCategoryList();
		jQuery('#catsList').nestedSortable({
			//disableNesting: 'no-nest',
			forcePlaceholderSize: true,
			handle: 'div',
			helper:	'clone',
			items: 'li',
			//maxLevels: 3,
			opacity: .6,
			placeholder: 'placeholder',
			revert: 250,
			tabSize: 25,
			tolerance: 'pointer',
			toleranceElement: '> div'
		});

		jQuery("#catEditForm").hide();
		jQuery("input:button").button();
	}

	function buildCatHtml(cat) {
		var parentTag = (cat.parentId)?"cat_" + cat.parentId + "_subs":"catsList";
		var tagText = "<li id='cat_" + cat.id + "' class='ui-state-default'>" + 
			"<div></div></li>";
		
		if (jQuery("#" + parentTag).length == 0) 
			jQuery("#cat_" + cat.parentId).append("<ol id='" + parentTag + "'></ol>");
		jQuery("#" + parentTag).append(tagText);
		appendFunctionLinks(cat);
	}

	function appendFunctionLinks(cat) {
		jQuery("#cat_" + cat.id + " > div").html(		
				cat.label + 			
				"<a href='javascript:void(0)' onclick='deleteCat(" + cat.id + ")' >" + deleteLinkText + "</a>" +
				"<a href='javascript:void(0)' onclick='modifyCat(" + cat.id + ")' >" + modifyLinkText + "</a>"
			);
	}
	
	function deleteCat(id) {
		var cat = categoriesById[id];
		if (!cat)
			return;
		
		jQuery("#catDeleteCatName").text(cat.label);
		
		jQuery("#catDeleteDiv").dialog({ 
						buttons: [
				            {
				                text: "Ok",
				                click: function() { removeCategory(id); $(this).dialog("close"); }			                
				            },
				            {
				                text: "Annulla",
				                click: function() { $(this).dialog("close"); }
				            }
				        ] ,
				        modal: true,
				        title: deleteTitle,
				        width: 500
				        }).keydown(function(event) {
				        	  if (event.keyCode == '13') { removeCategory(id); $(this).dialog("close"); };
				        });		
	}

	function modifyCat(id) {
		var cat = { id: greatestId + 1 , label: "" };		
		if (id) 
			cat = categoriesById[id];			

		if (!cat)
			return;
		
		jQuery("#catModifyName").val(cat.label);
		jQuery("#catModifyId").val(cat.id);
		jQuery("#catModifyOrigId").val(cat.id);
		jQuery("#catModifyNameError").text("");
		jQuery("#catModifyIdError").text("");
		
		jQuery("#createCatBtn").removeClass("ui-state-focus"); //needed for a jQuery bug
		jQuery("#catModifyDiv").dialog({ 
						buttons: [
				            {
				                text: "Ok",
				                click: confirmModifyCat
				            },
				            {
				                text: "Annulla",
				                click: function() { $(this).dialog("close"); }
				            }
				        ] ,
				        modal: true,
				        title: id?modifyTitle:createTitle,
				        width: 800
				        }).keydown(function(event) {
				        	  if (event.keyCode == '13') confirmModifyCat();
				        });		
	}	

	function confirmModifyCat() {
		var newName = jQuery.trim(jQuery("#catModifyName").val());
		var newId = Number(jQuery("#catModifyId").val());
		var origId = Number(jQuery("#catModifyOrigId").val());
		jQuery("#catModifyNameError").text("");
		jQuery("#catModifyIdError").text("");
		if (!newName) {
			jQuery("#catModifyNameError").text(requiredField);
			return;
		}
		
		if (isNaN(newId) || newId < 1) {
			jQuery("#catModifyIdError").text(insertPositiveNumber);
			return;
		}
		
		if (origId != newId && categoriesById[newId]) {
			jQuery("#catModifyIdError").text(duplicateId);
			return;
		}

		var cat = categoriesById[origId];
		if (!cat) {
			cat = {id : newId, label : newName, level : 0 };
			buildCatHtml(cat);
		} else {					
			var ids = (jQuery("#cat_" + origId).closest("ol").closest("li").attr('id') || '').match((/(.+)[-=_](.+)/));			
			cat.parentId = ids ? Number(ids[2]) : undefined;			
			cat.id = newId;
			cat.label = newName;			
			categoriesById[origId] = null;
			jQuery("#cat_" + origId).attr("id", "cat_" + newId);
			jQuery("#cat_" + origId + "_subs").attr("id", "cat_" + newId + "_subs");
			appendFunctionLinks(cat);			
		}
		categoriesById[cat.id] = cat;
		
		if (cat.id > greatestId)
			greatestId = cat.id; 
		
		jQuery("#catModifyDiv").dialog("close"); 
	}

	function removeCategory(id) {
		categoriesById[id] = null;
		jQuery("#cat_" + id).remove();
	}

	function countDashes(text) {
		var i = 0;
		while (text.substring(i, i + 1) == "-")
			i++;
		return i;		
	}

	function buildCatObject(desc) {
		var ret = new Object();
		ret.level = countDashes(desc);
		desc = desc.substr(ret.level);
		ret.level = Math.floor(ret.level / 2);

		var pieces = desc.split(":");
		if (pieces.length != 2)
			return null;

		ret.label = jQuery.trim(pieces[0]);
		ret.id = jQuery.trim(pieces[1]) - 0;
		if (isNaN(ret.id))
			return null;

		if (ret.id > greatestId)
			greatestId = ret.id; 
		
		return ret;
	}


	function serializeCats() {
		var hi = jQuery('#catsList').nestedSortable('toHierarchy');
		var catDesc = "";
		for(var item in hi) {
			var value = hi[item];
			catDesc += getCatDescription(value, 0);			
		}
		$("#content").val(catDesc);
	}

	function saveCats() {
		serializeCats();
		jQuery("#catEditForm").submit();
	}	

	function getCatDescription(hiObj, level) {
		if (!level)
			level = 0;

		if (!hiObj || !hiObj.id)
			return "";

		var cat = categoriesById[hiObj.id];
		if (!cat)
			return "";

		var desc = "";
		for (var i = 0; i < level; i++)
			desc += "--";

		desc += cat.label + " :" + cat.id + "\n";
		if (hiObj.children) {
			for(var item in hiObj.children) {
				var value = hiObj.children[item];
				desc += getCatDescription(value, level + 1);			
			}
		}
		return desc;
		
	}

	function dumpCategoryList() {
		var out = '';
		for (var id in categoriesById) {
			var cat = categoriesById[id];
			out += cat.id + " " + cat.label + " " + cat.level + " parent: " + cat.parentId + "\n";  
		}
		alert(out);
	}

	function dump(arr,level) {
		var dumped_text = "";
		if(!level) level = 0;

		//The padding given at the beginning of the line.
		var level_padding = "";
		for(var j=0;j<level+1;j++) level_padding += "    ";

		if(typeof(arr) == 'object') { //Array/Hashes/Objects
			for(var item in arr) {
				var value = arr[item];

				if(typeof(value) == 'object') { //If it is an array,
					dumped_text += level_padding + "'" + item + "' ...\n";
					dumped_text += dump(value,level+1);
				} else {
					dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
				}
			}
		} else { //Strings/Chars/Numbers etc.
			dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
		}
		return dumped_text;
	}
